diff --git a/lib/hive/setup/diagnostics.rb b/lib/hive/setup/diagnostics.rb
new file mode 100644
index 00000000..6d32b9a5
--- /dev/null
+++ b/lib/hive/setup/diagnostics.rb
@@ -0,0 +1,187 @@
+require "open3"
+require "timeout"
+require "hive/agent_profiles"
+
+module Hive
+  module Setup
+    # Read-only prerequisite checks used by `hive setup`.  The report is
+    # intentionally a value object: callers can present it to humans or emit
+    # it as JSON without parsing command output or exposing shell details.
+    class Diagnostics
+      EVIDENCE_LIMIT = 240
+      Result = Data.define(:name, :status, :detected_version, :required_version,
+                           :ownership, :evidence, :fix_command) do
+        def ok?
+          status == "ok"
+        end
+
+        def to_h
+          {
+            "name" => name,
+            "status" => status,
+            "detected_version" => detected_version,
+            "required_version" => required_version,
+            "ownership" => ownership,
+            "evidence" => evidence,
+            "fix_command" => fix_command
+          }
+        end
+      end
+
+      Report = Data.define(:results) do
+        def healthy?
+          results.all?(&:ok?)
+        end
+
+        def fetch(name)
+          results.find { |result| result.name == name } || raise(KeyError, "unknown diagnostic #{name}")
+        end
+
+        def to_h
+          { "checks" => results.map(&:to_h), "ok" => healthy? }
+        end
+      end
+
+      def initialize(runner: nil, agent_logged_in: nil, rails_ready: nil, sqlite_ready: nil,
+                     platform: nil, timeout_sec: 10)
+        @runner = runner || method(:capture)
+        @agent_logged_in = agent_logged_in || ->(name) { Hive::AgentProfiles.logged_in?(name) }
+        @rails_ready = rails_ready || -> { false }
+        @sqlite_ready = sqlite_ready || method(:sqlite_available?)
+        @platform = platform || platform_from_host
+        @timeout_sec = timeout_sec
+      end
+
+      def call
+        return unsupported_report unless %i[linux macos].include?(@platform)
+
+        checks = [
+          command_check("ruby", [ "ruby", "--version" ], required_version: "3.4", ownership: "external"),
+          command_check("git", [ "git", "--version" ], ownership: "external"),
+          command_check("tmux", [ "tmux", "-V" ], ownership: "external"),
+          gh_check,
+          agent_check(:claude),
+          agent_check(:codex),
+          command_check("node", [ "node", "--version" ], ownership: "external"),
+          command_check("npm", [ "npm", "--version" ], ownership: "external"),
+          command_check("qmd", [ "qmd", "--version" ], ownership: "hive_owned"),
+          component_check("rails_bundle", @rails_ready, ownership: "hive_owned"),
+          component_check("sqlite", @sqlite_ready, ownership: "external")
+        ]
+        Report.new(checks)
+      end
+
+      private
+
+      def unsupported_report
+        Report.new([
+          Result.new("platform", "error", nil, nil, "external", "unsupported platform", "use Linux or macOS (systemd-user / launchd required)")
+        ])
+      end
+
+      def command_check(name, argv, required_version: nil, ownership:)
+        output, error, exit_code = run(argv)
+        evidence = redact([ output, error ].compact.join("\n"))
+        if exit_code == 127
+          return Result.new(name, "missing", nil, required_version, ownership, evidence, install_hint(name))
+        end
+        return Result.new(name, "error", nil, required_version, ownership, evidence, install_hint(name)) unless exit_code.zero?
+
+        version = extract_version(output)
+        if required_version && (!version || below?(version, required_version))
+          Result.new(name, "version_too_old", version, required_version, ownership, evidence, install_hint(name))
+        else
+          Result.new(name, "ok", version, required_version, ownership, evidence, nil)
+        end
+      end
+
+      def gh_check
+        base = command_check("gh", [ "gh", "--version" ], ownership: "external")
+        return base unless base.ok?
+
+        _out, error, exit_code = run([ "gh", "auth", "status" ])
+        return base if exit_code.zero?
+
+        Result.new("gh", "unauthenticated", base.detected_version, nil, "external", redact(error), "gh auth login")
+      end
+
+      def agent_check(name)
+        profile = Hive::AgentProfiles.lookup(name)
+        base = command_check(name.to_s, [ profile.bin, profile.version_flag ],
+                             required_version: profile.min_version, ownership: "external")
+        return base unless base.ok?
+        return base if @agent_logged_in.call(name)
+
+        Result.new(name.to_s, "unauthenticated", base.detected_version, base.required_version,
+                   "external", "credential artifact not found", "#{profile.bin} login")
+      rescue Hive::AgentProfiles::UnknownAgent => error
+        Result.new(name.to_s, "error", nil, nil, "external", redact(error.message), nil)
+      end
+
+      def component_check(name, probe, ownership:)
+        ok = probe.call
+        Result.new(name, ok ? "ok" : "missing", nil, nil, ownership,
+                   ok ? "ready" : "not ready", ok ? nil : component_fix(name))
+      rescue StandardError => error
+        Result.new(name, "error", nil, nil, ownership, redact(error.message), component_fix(name))
+      end
+
+      def component_fix(name)
+        case name
+        when "rails_bundle" then "hive setup --only=web"
+        when "sqlite" then install_hint("sqlite3")
+        end
+      end
+
+      def run(argv)
+        result = @runner.call(argv, timeout_sec: @timeout_sec)
+        return result if result.is_a?(Array) && result.length == 3
+
+        [ "", "invalid diagnostic runner result", 1 ]
+      rescue Errno::ENOENT, Errno::EACCES
+        [ "", "command not found", 127 ]
+      rescue Timeout::Error
+        [ "", "timed out after #{@timeout_sec}s", 1 ]
+      rescue StandardError => error
+        [ "", error.message, 1 ]
+      end
+
+      def capture(argv, timeout_sec:)
+        out, err, status = Timeout.timeout(timeout_sec) { Open3.capture3(*argv) }
+        [ out, err, status.exitstatus ]
+      end
+
+      def sqlite_available?
+        require "sqlite3"
+        !SQLite3::SQLITE_VERSION.to_s.empty?
+      rescue LoadError
+        false
+      end
+
+      def platform_from_host
+        case RUBY_PLATFORM
+        when /darwin/i then :macos
+        when /linux/i then :linux
+        else :unsupported
+        end
+      end
+
+      def install_hint(name)
+        package = { "ruby" => "ruby", "gh" => "gh", "sqlite3" => "sqlite", "node" => "node", "npm" => "node" }.fetch(name, name)
+        @platform == :macos ? "brew install #{package}" : "sudo apt install #{package}"
+      end
+
+      def extract_version(value)
+        value.to_s[/\d+(?:\.\d+){0,2}/]
+      end
+
+      def below?(actual, required)
+        (actual.split(".").map(&:to_i) <=> required.split(".").map(&:to_i)).negative?
+      end
+
+      def redact(value)
+        value.to_s.gsub(/(?:token|secret|password|api[_-]?key)\s*[=:]\s*\S+/i, "[REDACTED]")[0, EVIDENCE_LIMIT]
+      end
+    end
+  end
+end
diff --git a/lib/hive/setup/qmd_installer.rb b/lib/hive/setup/qmd_installer.rb
new file mode 100644
index 00000000..93799a05
--- /dev/null
+++ b/lib/hive/setup/qmd_installer.rb
@@ -0,0 +1,134 @@
+require "fileutils"
+require "open3"
+require "timeout"
+require "hive/paths"
+
+module Hive
+  module Setup
+    # Owns the only mutable third-party bootstrap in native setup.  qmd is
+    # installed below Hive data, never into the user's global npm prefix.
+    class QmdInstaller
+      PACKAGE = "@tobilu/qmd".freeze
+      Result = Data.define(:status, :prefix, :executable, :message) do
+        def ok?
+          %w[installed unchanged linked].include?(status)
+        end
+
+        def to_h
+          { "status" => status, "prefix" => prefix, "executable" => executable, "message" => message }
+        end
+      end
+
+      def self.default_prefix
+        File.join(Hive::Paths.data_home, "qmd")
+      end
+
+      def initialize(prefix: self.class.default_prefix, link_path: File.join(Hive::Paths.bin_home, "qmd"),
+                     package: ENV.fetch("HIVE_QMD_NPM_PACKAGE", PACKAGE), runner: nil, timeout_sec: 120)
+        @prefix = File.expand_path(prefix)
+        @link_path = File.expand_path(link_path)
+        @package = package
+        @runner = runner || method(:capture)
+        @timeout_sec = timeout_sec
+      end
+
+      def install
+        return Result.new("missing_npm", @prefix, executable, "npm is required; install Node.js/npm and re-run hive setup") unless npm_available?
+
+        return link_existing if healthy?
+
+        staging = "#{@prefix}.tmp.#{Process.pid}.#{rand(1_000_000)}"
+        FileUtils.rm_rf(staging)
+        _out, err, status = run([ "npm", "install", "--global", "--prefix", staging, "--no-audit", "--no-fund", @package ])
+        return Result.new("install_failed", @prefix, executable, bounded(err)) unless status.zero?
+
+        _out, err, status = run([ "npm", "rebuild", "--global", "--prefix", staging, "better-sqlite3" ])
+        return Result.new("rebuild_failed", @prefix, executable, bounded(err)) unless status.zero?
+
+        staged_bin = File.join(staging, "bin", "qmd")
+        unless executable_healthy?(staged_bin)
+          return Result.new("invalid_install", @prefix, executable, "qmd install did not produce a runnable executable")
+        end
+
+        previous = "#{@prefix}.previous"
+        FileUtils.rm_rf(previous)
+        FileUtils.mv(@prefix, previous) if File.exist?(@prefix)
+        FileUtils.mv(staging, @prefix)
+        link_result = install_link
+        return link_result unless link_result.ok?
+
+        FileUtils.rm_rf(previous)
+        Result.new("installed", @prefix, executable, "qmd installed")
+      ensure
+        FileUtils.rm_rf(staging) if defined?(staging) && staging && File.exist?(staging)
+      end
+
+      private
+
+      def executable
+        File.join(@prefix, "bin", "qmd")
+      end
+
+      def npm_available?
+        _out, _err, status = run([ "npm", "--version" ])
+        status.zero?
+      end
+
+      def healthy?
+        executable_healthy?(executable)
+      end
+
+      def executable_healthy?(path)
+        return false unless File.file?(path) && File.executable?(path)
+
+        _out, _err, status = run([ path, "--version" ])
+        status.zero?
+      end
+
+      def link_existing
+        result = install_link
+        return result unless result.ok?
+
+        Result.new("unchanged", @prefix, executable, "qmd already installed")
+      end
+
+      def install_link
+        FileUtils.mkdir_p(File.dirname(@link_path))
+        if File.exist?(@link_path) || File.symlink?(@link_path)
+          target = File.realpath(@link_path) rescue nil
+          managed = File.realpath(executable) rescue executable
+          unless target == managed
+            return Result.new("link_collision", @prefix, executable,
+                              "existing qmd at #{@link_path} belongs to another installation; leaving it unchanged")
+          end
+        end
+        tmp = "#{@link_path}.tmp.#{Process.pid}.#{rand(1_000_000)}"
+        File.symlink(executable, tmp)
+        File.rename(tmp, @link_path)
+        Result.new("linked", @prefix, executable, "qmd linked")
+      ensure
+        File.unlink(tmp) if defined?(tmp) && tmp && File.symlink?(tmp)
+      end
+
+      def run(argv)
+        result = @runner.call(argv, timeout_sec: @timeout_sec)
+        result.is_a?(Array) && result.length == 3 ? result : [ "", "invalid qmd runner result", 1 ]
+      rescue Errno::ENOENT, Errno::EACCES
+        [ "", "command not found", 127 ]
+      rescue Timeout::Error
+        [ "", "timed out", 1 ]
+      rescue StandardError => error
+        [ "", error.message, 1 ]
+      end
+
+      def capture(argv, timeout_sec:)
+        out, err, status = Timeout.timeout(timeout_sec) { Open3.capture3(*argv) }
+        [ out, err, status.exitstatus ]
+      end
+
+      def bounded(value)
+        value.to_s.gsub(/(?:token|secret|password|api[_-]?key)\s*[=:]\s*\S+/i, "[REDACTED]")[0, 240]
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/app_bundle.rb b/lib/hive/web/app_bundle.rb
new file mode 100644
index 00000000..28c2dd75
--- /dev/null
+++ b/lib/hive/web/app_bundle.rb
@@ -0,0 +1,197 @@
+require "digest"
+require "fileutils"
+require "json"
+require "rubygems/package"
+require "securerandom"
+require "zlib"
+require "hive/paths"
+
+module Hive
+  module Web
+    # Locates source web assets for contributors and manages immutable XDG
+    # bundles for installed gems. Archive extraction deliberately implements a
+    # small allowlist instead of delegating to tar so an untrusted release
+    # archive cannot escape the staging directory through links or traversal.
+    class AppBundle
+      READY_FILE = ".hive-web-ready.json".freeze
+      Result = Data.define(:status, :path, :message) do
+        def ok?
+          %w[installed unchanged].include?(status)
+        end
+
+        def to_h
+          { "status" => status, "path" => path, "message" => message }
+        end
+      end
+
+      def initialize(version: Hive::VERSION, root: Hive::Paths.web_app_home, source_dir: nil,
+                     bundle_runner: nil)
+        @version = version.to_s
+        @root = File.expand_path(root)
+        @source_dir = source_dir || File.expand_path("../../../web", __dir__)
+        @bundle_runner = bundle_runner || method(:install_dependencies)
+      end
+
+      attr_reader :version
+
+      def current_path
+        File.join(@root, "current")
+      end
+
+      def current_dir
+        File.realpath(current_path)
+      rescue Errno::ENOENT, Errno::EINVAL
+        nil
+      end
+
+      # Explicit test/development overrides retain the old escape hatch. A
+      # source checkout comes next; an installed gem therefore falls through
+      # to its `current` immutable bundle without relying on cwd.
+      def resolve
+        override = ENV["HIVEBOX_WEB_APP_DIR"]
+        return File.expand_path(override) if app_candidate?(override)
+        return @source_dir if app_candidate?(@source_dir)
+
+        current = current_dir
+        current if valid_layout?(current) && ready?(current)
+      end
+
+      def ready?(dir = current_dir)
+        return false unless valid_layout?(dir)
+
+        stamp = File.join(dir, READY_FILE)
+        payload = JSON.parse(File.read(stamp))
+        payload["version"] == @version && payload["digest"].to_s.match?(/\A[0-9a-f]{64}\z/)
+      rescue Errno::ENOENT, JSON::ParserError
+        false
+      end
+
+      def install_from_archive!(archive, expected_sha256: nil)
+        archive = File.expand_path(archive)
+        return Result.new("missing_archive", nil, "web archive not found") unless File.file?(archive)
+
+        # `Hive::Digest` is an application namespace; spell the stdlib
+        # constant absolutely so archive verification remains correct after
+        # digest-reporting code has been loaded in the same process.
+        digest = ::Digest::SHA256.file(archive).hexdigest
+        if expected_sha256 && !secure_equal?(digest, expected_sha256.to_s.downcase)
+          return Result.new("digest_mismatch", nil, "web archive digest did not match the signed manifest")
+        end
+        return Result.new("unchanged", current_dir, "matching web bundle is already active") if ready?(current_dir) && current_dir.include?(digest)
+
+        staging = File.join(@root, ".staging-#{Process.pid}-#{SecureRandom.hex(6)}")
+        target = File.join(@root, "versions", "#{@version}-#{digest}")
+        FileUtils.mkdir_p(staging)
+        extract_safely!(archive, staging)
+        return Result.new("invalid_layout", nil, "web archive does not contain a Rails application") unless valid_layout?(staging)
+
+        unless @bundle_runner.call(staging)
+          return Result.new("bundle_failed", nil, "bundle install failed; prior web bundle remains active")
+        end
+
+        write_ready_stamp(staging, digest)
+        FileUtils.mkdir_p(File.dirname(target))
+        FileUtils.rm_rf(target) if File.exist?(target)
+        File.rename(staging, target)
+        activate!(target)
+        Result.new("installed", target, "web bundle activated")
+      rescue UnsafeArchive => error
+        Result.new("unsafe_archive", nil, error.message)
+      rescue Zlib::GzipFile::Error, Gem::Package::TarInvalidError => error
+        Result.new("invalid_archive", nil, "invalid web archive: #{error.message}")
+      ensure
+        FileUtils.rm_rf(staging) if defined?(staging) && staging && File.exist?(staging)
+      end
+
+      private
+
+      class UnsafeArchive < StandardError; end
+
+      def extract_safely!(archive, destination)
+        seen = []
+        Zlib::GzipReader.open(archive) do |gzip|
+          Gem::Package::TarReader.new(gzip) do |tar|
+            tar.each do |entry|
+              name = entry.full_name.to_s
+              validate_entry!(entry, name)
+              relative = normalized_relative(name)
+              next if relative.empty?
+
+              destination_path = File.join(destination, relative)
+              raise UnsafeArchive, "duplicate archive path #{name.inspect}" if seen.include?(relative)
+
+              seen << relative
+              if entry.directory?
+                FileUtils.mkdir_p(destination_path, mode: 0o755)
+              else
+                FileUtils.mkdir_p(File.dirname(destination_path))
+                File.open(destination_path, "wb", 0o644) { |file| IO.copy_stream(entry, file) }
+              end
+            end
+          end
+        end
+      end
+
+      def validate_entry!(entry, name)
+        raise UnsafeArchive, "absolute archive path #{name.inspect}" if name.start_with?("/", "\\")
+        raise UnsafeArchive, "path traversal in archive entry #{name.inspect}" if name.split("/").include?("..")
+        raise UnsafeArchive, "unsafe archive mode for #{name.inspect}" if (entry.header.mode & 0o022) != 0
+        return if entry.file? || entry.directory?
+
+        raise UnsafeArchive, "archive links and special files are not accepted (#{name.inspect})"
+      end
+
+      def normalized_relative(name)
+        relative = name.delete_prefix("./").sub(%r{/\z}, "")
+        root = "hive-web-#{@version}"
+        if relative == root
+          ""
+        elsif relative.start_with?("#{root}/")
+          relative.delete_prefix("#{root}/")
+        elsif relative.start_with?("hive-web-")
+          raise UnsafeArchive, "web archive version does not match #{@version}"
+        else
+          relative
+        end
+      end
+
+      def valid_layout?(dir)
+        dir && File.file?(File.join(dir, "config", "application.rb")) &&
+          File.file?(File.join(dir, "Gemfile")) && File.file?(File.join(dir, "bin", "rails"))
+      end
+
+      # The legacy override remains intentionally permissive: container and
+      # test callers have long supplied only the Rails application marker and
+      # may provide their own `bin/rails` at execution time. Immutable release
+      # bundles use the stricter layout gate above before activation.
+      def app_candidate?(dir)
+        dir && File.file?(File.join(dir, "config", "application.rb"))
+      end
+
+      def write_ready_stamp(dir, digest)
+        File.write(File.join(dir, READY_FILE), JSON.generate({ "version" => @version, "digest" => digest }) + "\n")
+      end
+
+      def activate!(target)
+        FileUtils.mkdir_p(@root)
+        tmp = "#{current_path}.tmp.#{Process.pid}.#{SecureRandom.hex(4)}"
+        File.symlink(target, tmp)
+        File.rename(tmp, current_path)
+      ensure
+        File.unlink(tmp) if defined?(tmp) && tmp && File.symlink?(tmp)
+      end
+
+      def install_dependencies(dir)
+        Dir.chdir(dir) { system({ "BUNDLE_GEMFILE" => File.join(dir, "Gemfile") }, "bundle", "install", "--deployment") }
+      end
+
+      # Same-length digest comparison avoids accidentally turning a manifest
+      # check into a timing oracle when an app embeds this primitive remotely.
+      def secure_equal?(left, right)
+        return false unless left.bytesize == right.bytesize
+
+        left.bytes.zip(right.bytes).reduce(0) { |memo, (a, b)| memo | (a ^ b) }.zero?
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/daemon_control.rb b/lib/hive/web/daemon_control.rb
new file mode 100644
index 00000000..ddbd0827
--- /dev/null
+++ b/lib/hive/web/daemon_control.rb
@@ -0,0 +1,43 @@
+require "hive/commands/daemon"
+require "hive/commands/daemon/service_installer"
+require "hive/invoked_binary"
+
+module Hive
+  module Web
+    # Narrow bridge shared by Rails maintenance jobs and CLI-adjacent web
+    # callers. It deliberately has a closed action set and never accepts
+    # command text, project paths, or arbitrary manager arguments.
+    class DaemonControl
+      ACTIONS = %w[start restart repair].freeze
+
+      def initialize(binary_path: Hive::InvokedBinary.path)
+        @binary_path = binary_path
+      end
+
+      def status
+        Hive::Commands::Daemon.new("status").status_payload
+      end
+
+      def perform!(action)
+        action = action.to_s
+        raise ArgumentError, "unsupported daemon maintenance action #{action.inspect}" unless ACTIONS.include?(action)
+        raise Hive::Error, "cannot resolve the current Hive executable for daemon maintenance" if @binary_path.to_s.empty?
+
+        installer = Hive::Commands::Daemon::ServiceInstaller.new(binary_path: @binary_path)
+        case action
+        when "repair"
+          outcome = installer.install!(autostart: true, force: true)
+          raise Hive::Error, "daemon service repair failed" if outcome.failed? || outcome.drifted?
+        else
+          raise Hive::Error, "daemon service is not installed" unless installer.control!(action)
+        end
+
+        {
+          "action" => action,
+          "service" => installer.lifecycle_status,
+          "daemon" => status
+        }
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/loopback.rb b/lib/hive/web/loopback.rb
new file mode 100644
index 00000000..1b4960ad
--- /dev/null
+++ b/lib/hive/web/loopback.rb
@@ -0,0 +1,66 @@
+require "ipaddr"
+require "socket"
+
+module Hive
+  module Web
+    # Listener policy is decided before Rails starts; request trust is checked
+    # again in Rails using the socket peer and Host. Neither half alone grants
+    # the local no-login mode.
+    module Loopback
+      Policy = Data.define(:bind, :local_mode, :unsafe) do
+        def local_mode?
+          local_mode
+        end
+
+        def unsafe?
+          unsafe
+        end
+      end
+
+      module_function
+
+      def listener?(bind, resolver: method(:resolve))
+        value = bind.to_s.strip
+        return loopback_ip?(value) unless value.casecmp?("localhost")
+
+        addresses = Array(resolver.call(value))
+        !addresses.empty? && addresses.all? { |address| loopback_ip?(address) }
+      rescue SocketError, ArgumentError
+        false
+      end
+
+      def policy!(bind:, config:, unsafe_no_auth: false, resolver: method(:resolve))
+        return Policy.new(bind.to_s, true, false) if listener?(bind, resolver: resolver)
+        return Policy.new(bind.to_s, false, true) if unsafe_no_auth
+        return Policy.new(bind.to_s, false, false) if github_auth_usable?(config)
+
+        raise Hive::ConfigError,
+              "hive web: refusing non-loopback bind #{bind.inspect} without GitHub owner/claim auth; " \
+              "configure web.github.client_id or pass --unsafe-no-auth"
+      end
+
+      def trusted_request?(enabled:, remote_ip:, host:)
+        enabled && loopback_ip?(remote_ip) && allowed_host?(host)
+      end
+
+      def allowed_host?(host)
+        value = host.to_s.downcase.sub(/\A\[(.*)\]\z/, '\\1')
+        %w[localhost 127.0.0.1 ::1].include?(value)
+      end
+
+      def loopback_ip?(value)
+        IPAddr.new(value.to_s).loopback?
+      rescue IPAddr::InvalidAddressError
+        false
+      end
+
+      def github_auth_usable?(config)
+        !config.dig("github", "client_id").to_s.strip.empty?
+      end
+
+      def resolve(name)
+        Addrinfo.getaddrinfo(name, nil, nil, Socket::SOCK_STREAM).map(&:ip_address).uniq
+      end
+    end
+  end
+end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c29..1c3af951 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -27,6 +27,7 @@ require "hive/commands/markers"
 require "hive/commands/daemon"
 require "hive/commands/bot"
 require "hive/commands/metrics"
+require "hive/commands/setup"
 
 class HiveCliTest < Minitest::Test
   include HiveTestHelper
@@ -125,6 +126,21 @@ class HiveCliTest < Minitest::Test
     end
   end
 
+  def test_setup_wires_native_options_and_returns_its_phase_exit_code
+    with_command_new_stub(Hive::Commands::Setup, return_value: 0) do |calls|
+      _out, _err, status = with_captured_exit do
+        Hive::CLI.start([ "setup", "/tmp/project", "--diagnose-only", "--json", "--force", "--no-service", "--only", "qmd" ])
+      end
+
+      assert_equal 0, status
+      assert_equal [ "/tmp/project" ], calls.first.fetch(:args)
+      assert_equal(
+        { diagnose_only: true, json: true, force: true, service: false, only: "qmd" },
+        calls.first.fetch(:kwargs)
+      )
+    end
+  end
+
   def test_doctor_loads_project_config_and_exits_with_command_status
     loaded = []
     with_replaced_singleton_method(Hive::Config, :load, lambda { |path|
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788e..53445fb2 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -345,6 +345,7 @@ class HiveCommandsDaemonTest < Minitest::Test
     }
     fake = Struct.new(:state) do
       def service_state = state
+      def configured_executable = "/opt/hive/bin/hive"
     end.new(state)
     require "hive/commands/daemon/service_installer"
     out, _err = with_replaced_singleton_method(
@@ -356,6 +357,8 @@ class HiveCommandsDaemonTest < Minitest::Test
     assert_equal true, doc.fetch("service_installed")
     assert_equal true, doc.fetch("service_enabled")
     assert_equal "/home/u/.config/systemd/user/hive-daemon.service", doc.fetch("unit_path")
+    assert_equal "/opt/hive/bin/hive", doc.fetch("configured_executable")
+    assert_equal "unknown", doc.fetch("drift")
     # Existing fields must survive the merge.
     assert_equal true, doc.fetch("running")
     assert_equal 1234, doc.fetch("pid")
@@ -365,6 +368,30 @@ class HiveCommandsDaemonTest < Minitest::Test
     assert_empty schema.validate(doc).map { |error| error["error"] }
   end
 
+  def test_status_json_reports_path_drift_and_exact_repair_command
+    command = daemon("status", json: true)
+    command.define_singleton_method(:current_binary_path) { "/new/bin/hive" }
+    write_pid_payload(pid: 1234)
+    command.define_singleton_method(:pid_alive?) { |pid| pid == 1234 }
+    command.define_singleton_method(:pid_owned_by_us?) { |_payload, pid| pid == 1234 }
+    state = {
+      "platform" => "linux",
+      "unit_path" => "/home/u/.config/systemd/user/hive-daemon.service",
+      "service_installed" => true,
+      "service_enabled" => true,
+      "configured_executable" => "/old/bin/hive",
+      "configured_version" => Hive::VERSION
+    }
+    command.define_singleton_method(:probe_service_state) { state }
+
+    out, _err = capture_io { command.call }
+    doc = JSON.parse(out)
+
+    assert_equal "path", doc.fetch("drift")
+    assert_equal "hive daemon install --force", doc.fetch("recommended_action")
+    assert_equal "/new/bin/hive", doc.fetch("current_executable")
+  end
+
   def test_status_json_degrades_service_fields_to_null_when_probe_raises
     command = daemon("status", json: true)
     write_pid_payload(pid: 1234)
@@ -950,9 +977,11 @@ class HiveCommandsDaemonTest < Minitest::Test
     File.write(command.pid_file, "not yaml")
     assert_nil command.send(:read_pid_file_payload)
 
-    payload = command.send(:pid_file_payload, 456, "supplied")
+    payload = command.send(:pid_file_payload, 456, "supplied", executable: "/opt/hive/bin/hive", version: "1.2.3")
     assert_equal 456, payload.fetch("pid")
     assert_equal "supplied", payload.fetch("process_start_time")
+    assert_equal "/opt/hive/bin/hive", payload.fetch("executable")
+    assert_equal "1.2.3", payload.fetch("version")
   end
 
   def test_read_live_pid_requires_alive_pid_owned_by_this_daemon
diff --git a/test/unit/commands/service_installer/base_test.rb b/test/unit/commands/service_installer/base_test.rb
index 09980af6..817d713c 100644
--- a/test/unit/commands/service_installer/base_test.rb
+++ b/test/unit/commands/service_installer/base_test.rb
@@ -249,6 +249,23 @@ class ServiceInstallerBaseTest < Minitest::Test
     end
   end
 
+  def test_configured_executable_reads_systemd_and_launchd_definitions_without_execution
+    with_tmp_dir do |dir|
+      linux = TestInstaller.new(host_os: "linux", home: dir, systemctl_available: false)
+      FileUtils.mkdir_p(File.dirname(linux.target_path))
+      File.write(linux.target_path, "Environment=HIVE_BIN=/opt/Hive\\ Bin/hive\nExecStart=/ignored/hive daemon start\n")
+      assert_equal "/opt/Hive Bin/hive", linux.configured_executable,
+                   "systemd's HIVE_BIN is shell-split exactly as the unit parser would"
+
+      mac = TestInstaller.new(host_os: "darwin", home: dir, launchctl_available: false)
+      FileUtils.mkdir_p(File.dirname(mac.target_path))
+      File.write(mac.target_path, <<~PLIST)
+        <plist><dict><key>ProgramArguments</key><array><string>/Applications/Hive &amp; Tools/hive</string><string>daemon</string></array></dict></plist>
+      PLIST
+      assert_equal "/Applications/Hive & Tools/hive", mac.configured_executable
+    end
+  end
+
   def test_service_state_linux_disabled_when_systemctl_unavailable
     with_tmp_dir do |dir|
       # systemctl missing → enabled must be false and the runner must
